#include "triangle_mesh_type.h"
#include <vcg/math/random_generator.h>
#include <vcg/complex/algorithms/create/platonic.h>
#include <vcg/complex/algorithms/refine.h>

using namespace vcg;
math::MarsenneTwisterRNG rnd;
void GenerateBox(MyTriMesh &mesh, float size)
{
  mesh.Clear();
  tri::Box<MyTriMesh>(mesh, Box3f(Point3f(0,0,0), Point3f(size,size,size)));
  tri::UpdateTopology<MyTriMesh>::FaceFace(mesh);
  
  for(int i=0;i<7;++i)
    tri::Refine<MyTriMesh, tri::MidPoint<MyTriMesh> >(mesh,tri::MidPoint<MyTriMesh>(&mesh),0.0f);
			
  tri::UpdateNormal<MyTriMesh>::PerVertexNormalizedPerFace(mesh);
  tri::UpdateBounding<MyTriMesh>::Box(mesh);
}


void RandomizeMesh(MyTriMesh &mesh, float threshold)
{
  for (int i = 0; i < mesh.vert.size(); i++)
  {
    Point3f randomVector = math::GeneratePointInUnitBallUniform<float>(rnd);
    mesh.vert[i].P() += randomVector*threshold; 
  }
  tri::UpdateNormal<MyTriMesh>::PerVertexNormalizedPerFace(mesh);
  
}

